﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShipMovement : MonoBehaviour 
{
	float speed = 4;
	float minRotation = -25;
	float maxRotation = 25;
	public float sidePosLimit = 15;
	static float totalWeight;
	float rotationZ;
	float sidewaysMovement;
	float sidewaysSpeed = 10;
	public GameObject leftCam;
	public GameObject midCam;
	public GameObject rightCam;
	private bool alive;
    public GameObject Loss;

	public GameObject _camera;

	// Use this for initialization
	void Start () 
	{
		rotationZ = 0;
		sidewaysMovement = 0;
		alive = true;
        Loss.SetActive(false);
    }
	
	// Update is called once per frame
	void FixedUpdate () 
	{
		if (alive) 
		{
			rotateShip ();
			moveShip ();
			moveCamera ();
		} 
		else 
		{
			if (transform.parent.transform.position.y > -6) 
			{
				transform.parent.transform.Translate (Vector3.down * Time.deltaTime * 2);
			}
            Loss.SetActive(true);
		}	  

		//Debug.Log(totalWeight);
	}

	public static void UpdateWeight(float weight)
	{
		//float temp = totalWeight;
     	totalWeight += weight;
		totalWeight = Mathf.Clamp (totalWeight, -4, 4);

		//if (totalWeight > 5 || totalWeight < -5) //This number changes max speed
		//	totalWeight = temp;
	}

	private void moveShip()
	{
		//move the ship forward
		transform.parent.parent.transform.Translate(Vector3.forward * Time.deltaTime * speed);


		//move the ship sideways
		sidewaysMovement = transform.localRotation.z * Time.deltaTime;
		transform.parent.transform.Translate(new Vector3(-sidewaysMovement * sidewaysSpeed, 0, 0));
		Vector3 pos = transform.parent.position;
		pos.x = Mathf.Clamp(pos .x, -sidePosLimit, sidePosLimit);
		transform.parent.transform.position = pos;
	}

	private void rotateShip()
	{
		rotationZ += speed * Time.deltaTime * totalWeight;
		rotationZ = Mathf.Clamp(rotationZ, minRotation, maxRotation);
		transform.localEulerAngles = new Vector3(transform.localEulerAngles.x, transform.localEulerAngles.y, rotationZ);
	}

	private void moveCamera()
	{
		if (transform.parent.transform.position.x >= sidePosLimit) 
		{
			float step = 2 * Time.deltaTime;
			_camera.transform.position = Vector3.MoveTowards (_camera.transform.position, leftCam.transform.position, step); 
		} 
		else if (transform.parent.transform.position.x <= -sidePosLimit) 
		{
			float step = 2 * Time.deltaTime;
			_camera.transform.position = Vector3.MoveTowards (_camera.transform.position, rightCam.transform.position, step); 
		} 
		else 
		{
			float step = 2 * Time.deltaTime;
			_camera.transform.position = Vector3.MoveTowards (_camera.transform.position, midCam.transform.position, step); 
		}
	}

	void OnTriggerEnter(Collider other)
	{
		if (other.gameObject.tag == "hazard") 
		{
			Debug.Log ("Hit");
			alive = false;
		}
	}


}
